Index: trunk/kernel/kern/keysdb.c
===================================================================
--- trunk/kernel/kern/keysdb.c	(revision 1)
+++ trunk/kernel/kern/keysdb.c	(revision 1)
@@ -0,0 +1,243 @@
+/*
+ * keysdb.c - fixed radix-cache implementation
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <libk.h>
+#include <kdmsg.h>
+#include <bits.h>
+#include <page.h>
+#include <ppm.h>
+#include <pmm.h>
+#include <thread.h>
+#include <task.h>
+#include <kmem.h>
+#include <keysdb.h>
+
+#define KEYS_PER_REC_LOG2   6
+
+////////////////////////////////////
+error_t keysdb_init( keysdb_t * db )
+                     uint32_t   key_width )
+{
+	page_t     * page;
+	kmem_req_t   req;
+  
+	db->records_nr   = CONFIG_PMM_PAGE_SIZE / sizeof(keys_record_t*);
+	db->records_bits = bits_log2(db->records_nr);
+
+    db->keys_nr      = KEYS_PER_RECORD;
+    db->keys_bits    = bits_log2( db->keys_nr );
+
+    // allocates one single page
+	req.type  = KMEM_PAGE;
+	req.size  = 0;
+	req.flags = AF_USER | AF_ZERO;
+	page = kmem_alloc(&req);
+	if(page == NULL) return ENOMEM;
+  
+	db->root = ppm_page2addr( page );
+	db->page = page;
+
+	return 0;
+}
+
+///////////////////////////////////////
+void keysdb_destroy( keysdb_t * db )
+{
+	kmem_req_t req;
+	uint32_t   i;
+
+	req.type = KMEM_KEYSREC;
+
+	for( i=0 ; i < db->records_nr ; i++ )
+	{
+		if(db->root[i] == NULL) continue;
+
+		req.ptr = db->root[i];
+		kmem_free(&req);
+	}
+
+	req.type = KMEM_PAGE;
+	req.ptr = db->page;
+	kmem_free(&req);
+}
+
+//////////////////////////////////
+void keysdb_print( keysdb_t * db,
+                   char     * name )
+{
+	uint32_t        i;  
+	uint32_t        j;
+    keys_record_t * rec;
+ 
+	printk(INFO, "%s / keys_per_record = %d / records = %d\n", 
+           name, db->keys_nr , db->records_nr );
+
+	for( i=0 ; i < db->records_nr; i++ )
+	{
+        rec = db_root[i];   
+		if( rec == NULL ) continue;
+    
+	    printk(INFO, "record[%d] @ = 0x%x] [", index , rec );
+	    for( j=0; j < db->keys_nr ; i++) printk(INFO, "  val[%d] = %x\n", j , rec->tbl[j]);
+	}
+}
+
+/////////////////////////////////////
+error_t keysdb_insert( keysdb_t * db,
+                       uint32_t   key,
+                       void     * value )
+{
+    // Check key 
+    if( key >> (db->keys_bits + db->records_bits) ) return EINVAL;
+
+    // compute indexes
+    uint32_t        bits      = db->keys_bits;
+	uint32_t        rec_index = key >> bits;              // index in records table
+	uint32_t        key_index = key & ((1 << bits) - 1);  // index in record
+
+	kmem_req_t      req;        // kmem request for new record
+	keys_record_t * rec;        // pointer on selected record
+	bool_t          isAtomic;
+
+    // get address of pointer on the selected record in first level table.
+    // it can be NULL if the selected record has not be allocated yet.
+	volatile keys_record_t ** recptr = &db->root[record_index];
+
+    // we must allocate memory for the selected record if record pointer is NULL,
+    // and atomically update the records table with the new record pointer.
+	while( *recptr == NULL )
+	{
+        // allocate memory for record
+        req.type = KMEM_KEYSREC;
+        req.size = sizeof(keys_record_t);
+        req.flags = AF_USER | AF_ZERO;
+        rec = kmem_alloc(&req);
+        if( rec == NULL) return ENOMEM;
+
+        // try to update records array
+		isAtomic = cpu_atomic_cas( &db->root[record_index] , 0 , (uint32_t)rec );
+
+        // release record memory if not atomic
+        if( isAtomic == false )
+	    {
+		    req.ptr = rec;
+		    kmem_free(&req);
+	    }
+	}
+
+    // get pointer on selected record.
+	rec = db->root[record_index];
+
+    // check selected slot empty in selected record
+	if(rec->tbl[key_index] != NULL) return EEXIST;
+
+    // register the value
+	rec->tbl[key_index] = value;
+
+	return 0;
+}
+
+////////////////////////////////////
+void * keysdb_remove( keysdb_t * db,
+                      uint32_t   key )
+{
+    // compute indexes
+    uint32_t        bits      = db->keys_bits;
+	uint32_t        rec_index = key >> bits;              // index in records table
+	uint32_t        key_index = key & ((1 << bits) - 1);  // index in record
+  
+    // get record pointer
+	keys_record_t * rec = db->root[record_index];
+ 
+	if(rec == NULL) return NULL;
+
+    // get value
+	void * value = rec->tbl[key_index];
+
+    // reset selected slot
+	rec->tbl[key_index] = NULL;
+	cpu_wbflush();
+
+	return value;
+}
+
+////////////////////////////////////
+void * keysdb_lookup( keysdb_t * db,
+                      uint32_t   key )
+{
+    // compute indexes
+    uint32_t        bits      = db->keys_bits;
+	uint32_t        rec_index = key >> db->keys_bits;
+	uint32_t        key_index = key & ((1 << bits) - 1);
+
+    // get record pointer
+	keys_record_t * recptr = db->root[rec_index]; 
+
+    // compute value
+	void * value = (recptr == NULL) ? NULL : recptr->tbl[key_index];
+
+	return value;
+}
+
+
+/*
+///////////////////////////////////
+error_t keysdb_bind( keysdb_t * db,
+                     uint32_t   key_start, 
+                     uint32_t   keys_nr,
+                     void     * value )
+{
+	error_t err;
+	uint32_t i;
+
+	err = 0;
+
+	for(i = 0; i < keys_nr; i++)
+	{
+		err = keysdb_insert(db, key_start + i, value);
+		if(err != 0) break;
+	}
+
+	while((err != 0) && (i != 0))
+	{
+		i--;
+		keysdb_remove(db, key_start + i);
+	}
+
+	return err;
+}
+
+/////////////////////////////////////
+error_t keysdb_unbind( keysdb_t * db,
+                       uint32_t   key_start,
+                       uint32_t   keys_nr )
+{
+	uint32_t i;
+
+	for(i = 0; i < keys_nr; i++)
+		(void)keysdb_remove(db , key_start + i);
+
+	return 0;
+}
+
+*/
Index: trunk/kernel/kern/keysdb.h
===================================================================
--- trunk/kernel/kern/keysdb.h	(revision 1)
+++ trunk/kernel/kern/keysdb.h	(revision 1)
@@ -0,0 +1,133 @@
+/*
+ * keysdb.h - Two Levels Radix-tree Interface
+ * 
+ * Authors Ghassan Almalless (2008,2009,2010,2011,2012)
+ *         Alain Greiner (2016)
+ *
+ * Copyright  UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _KEYS_DB_H_
+#define _KEYS_DB_H_
+
+#include <types.h>
+#include <kmem.h>
+
+#define KEYS_PER_REC        64
+
+/*******************************************************************************************
+ * This define the second level in the two level radix-tree, called a record.
+ * A record is an array of KEYS_PER_RECORD pointers.
+ * Each entry is a (void *) pointer on a key-addressable item.
+ * The memory is dynamically allocated for a record only if this record contains 
+ * a least one non NULL entry. 
+ ******************************************************************************************/
+
+typedef struct keys_record_s
+{
+	void * tbl[KEYS_PER_REC];
+}
+keys_record_t;
+
+/*******************************************************************************************
+ * This structure defines the two levels radix-tree descriptor.
+ * The key is split in two fields : a record_index (MSB) / a key_index (LSB)
+ * The first level in the two levels radix-tree is an array of pointers on records.
+ * The number of entries in this array is fixed as [sizeof(page) / sizeof(pointer)].
+ * The total number of key values is [sizeof(page) / sizeof(pointer)] * KEYS_PER_RECORD.
+ ******************************************************************************************/
+
+typedef struct keysdb_s
+{
+	keys_record_t ** root;           /*! pointer on array of records pointers             */
+	uint32_t         records_nr;     /*! number of entries in records array               */
+	uint32_t         records_bits;   /*! number of bits to code the record index          */
+    uint32_t         keys_nr;        /*! number of entries (keys) in a record             */
+	uint32_t         keys_bits;      /*! number of bits to code the key index             */
+	page_t         * page;           /*! page descriptor containing the records array     */
+}
+keysdb_t;
+
+
+/*******************************************************************************************
+ * This function initialises the two levels radix-tree descriptor, and allocates
+ * memory (one physical page) to store the records array.
+ * @ db      : pointer on the radix-tree descriptor.
+ * @ returns 0 if success / returns ENOMEM if no more memory.      
+ ******************************************************************************************/
+error_t keysdb_init( keysdb_t * db );
+
+/*******************************************************************************************
+ * This function releases all memory allocated to store the array of records pointers,
+ * and the records themselve. 
+ * @ db      : pointer on the radix-tree descriptor.
+ ******************************************************************************************/
+void keysdb_destroy( keysdb_t * db );
+
+/*******************************************************************************************
+ * This function insert a new item in the two level radix-tree.
+ * It dynamically allocates memory for a new record if required.
+ * @ db      : pointer on the radix-tree descriptor.
+ * @ key     : key value used to address the radix tree
+ * @ value   : pointer on item to be registered in radix-tree.
+ * @ returns 0 if success / returns EINVAL if illegal key value.
+ ******************************************************************************************/
+error_t keysdb_insert( keysdb_t * db,
+                       uint32_t   key,
+                       void     * value );
+
+/*******************************************************************************************
+ * This function removes an item identified by its key, and returns a pointer
+ * on the removed item.
+ * @ db      : pointer on the radix-tree descriptor.
+ * @ key     : key value.
+ * @ returns item pointer if success / returns NULL if failure.
+ ******************************************************************************************/
+void * keysdb_remove( keysdb_t * db,
+                      uint32_t   key );
+
+/*******************************************************************************************
+ * This function returns the pointer on the item identified by its key.
+ * @ db      : pointer on the radix-tree descriptor.
+ * @ key     : key value.
+ * @ returns item pointer if success / returns NULL if failure.
+ ******************************************************************************************/
+void * keysdb_lookup( keysdb_t * db, 
+                      uint32_t   key );
+
+/*******************************************************************************************
+ * This function displays the content of a two levels radix_tree.
+ * @ db      : pointer on the radix-tree descriptor.
+ * @ name    : string identifying the radix-tree.
+ ******************************************************************************************/
+void keysdb_print( keysdb_t * db,
+                   char     * name );
+
+
+/* TODO the two following functions deprecated [AG] */
+
+/*******************************************************************************************
+ ******************************************************************************************/
+error_t keysdb_bind( keysdb_t *db, uint32_t key_start, uint32_t keys_nr, void *value);
+
+/*******************************************************************************************
+ ******************************************************************************************/
+error_t keysdb_unbind( keysdb_t *db, uint32_t key_start, uint32_t keys_nr);
+
+#endif	/* _KEYS_DB_H_ */
+
Index: trunk/kernel/kern/kmagics.h
===================================================================
--- trunk/kernel/kern/kmagics.h	(revision 1)
+++ trunk/kernel/kern/kmagics.h	(revision 1)
@@ -0,0 +1,41 @@
+/*
+ * kern/kmagics.h - magic numbers used to identify kernel objects
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _KMAGICS_H_
+#define _KMAGICS_H_
+
+#define MEM_CHECK_VAL     0xA5A5A5A5
+#define SCHED_CHECK_VAL   0xDEADBEEF
+#define LIST_NEXT_DEAD    0x0000b0C1
+#define LIST_PRED_DEAD    0x0000c0b1
+#define LIST_SNEXT_DEAD   0x0000A0A1
+#define POBJECT_CREATED   0x0000A5B5
+#define SEMAPHORE_ID      0xA0B1C0B3
+#define COND_VAR_ID       0xB1CA0BA5
+#define KCOND_VAR_ID      0xB3B0A3A3
+#define BARRIER_ID        0xCFA5B1A3
+#define RWLOCK_ID         0xD1A5B1EF
+#define THREAD_ID         0xDEEFBAAD
+#define PPM_ID            0xF0F0A5A5
+#define ALRM_INFO_ID      0xAF5FABE5
+
+#endif	/* _KMAGICS_H_ */
Index: trunk/kernel/kern/kthread_create.c
===================================================================
--- trunk/kernel/kern/kthread_create.c	(revision 1)
+++ trunk/kernel/kern/kthread_create.c	(revision 1)
@@ -0,0 +1,88 @@
+/*
+ * kern/kthread_create.c - kernel-level threads creation
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012,2013,2014,2015 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <kmem.h>
+#include <cpu.h>
+#include <thread.h>
+#include <process.h>
+#include <list.h>
+#include <ppm.h>
+#include <pmm.h>
+#include <signal.h>
+#include <scheduler.h>
+#include <spinlock.h>
+#include <cluster.h>
+
+////////////////////////////////
+static void kthread_exit( void )
+{
+	thread_t * this = CURRENT_THREAD;
+	
+	thread_dmsg( 1, "Kernel Thread %x on CPU %d has finished\n",
+	             this, current_cpu->gid );
+	
+	sys_thread_exit(0); //sched_exit(this);
+	
+	PANIC ("Thread %x, CPU %d must never return", this, current_cpu->gid);
+}
+
+void thread_init(thread_t *thread);
+
+struct thread_s* kthread_create(struct process_s *process, kthread_t *kfunc, void *arg, uint_t cpu_lid)
+{
+	kmem_req_t req;
+	register struct page_s *page;
+	register thread_t *thread;
+  
+	req.type  = KMEM_PAGE;
+	req.size  = ARCH_THREAD_PAGE_ORDER;
+	req.flags = AF_KERNEL | AF_ZERO | AF_REMOTE;
+	//req.ptr   = clusters_tbl[cid].cluster;  
+	req.ptr   = current_cluster;  
+	page      = kmem_alloc(&req);
+  
+	if(page == NULL) return NULL;
+
+	thread = ppm_page2addr(page);
+
+	thread_init(thread);
+
+	//thread_set_current_cpu(thread, &clusters_tbl[cid].cluster->cpu_tbl[cpu_lid]);
+	thread_set_current_cpu(thread, &current_cluster->cpu_tbl[cpu_lid]);
+	thread->ecid		= current_cluster->id;
+	thread->egid		= current_cluster->cpu_tbl[cpu_lid].gid;
+	sched_setpolicy(thread, SCHED_RR);
+	
+	thread->process                 = process;
+	thread->type                 = KTHREAD;
+	thread->state		     = S_KERNEL;
+	thread->info.sig_mask        = SIG_DEFAULT_MASK;
+	thread->info.attr.entry_func = (void*)kfunc;
+	thread->info.attr.exit_func  = (void*)kthread_exit;
+	thread->info.attr.arg1       = arg;
+	thread->info.attr.tid        = (uint_t) thread;
+	thread->info.attr.pid        = process->pid;
+	thread->info.page            = page;
+  
+	cpu_context_init(&thread->pws, thread);
+	return thread;
+}
Index: trunk/kernel/kern/mcs_sync.c
===================================================================
--- trunk/kernel/kern/mcs_sync.c	(revision 1)
+++ trunk/kernel/kern/mcs_sync.c	(revision 1)
@@ -0,0 +1,195 @@
+/*
+ * kern/mcs_sync.c - ticket-based barriers and locks synchronization
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <types.h>
+#include <mcs_sync.h>
+#include <thread.h>
+#include <cpu.h>
+#include <kdmsg.h>
+
+#define mcs_barrier_flush(_ptr)						\
+	do{								\
+		cpu_invalid_dcache_line(&(_ptr)->phase);		\
+		cpu_invalid_dcache_line(&(_ptr)->ticket);		\
+		cpu_invalid_dcache_line(&(_ptr)->ticket2);		\
+		cpu_invalid_dcache_line(&(_ptr)->cntr);			\
+	}while(0);
+
+/////////////////////////////////////////////////
+//FIXME: why all these dcache_invalidate ? [AG]
+/////////////////////////////////////////////////
+
+///////////////////////////////////////////
+void mcs_barrier_init( mcs_barrier_t * ptr,
+                       char          * name,
+                       uint32_t        count )
+{
+	ptr->val.value     = count;
+	ptr->phase.value   = 0;
+	ptr->cntr.value    = count;
+	ptr->ticket.value  = 0;
+	ptr->ticket2.value = 0;
+	ptr->name          = name;
+	
+	cpu_wbflush();
+	cpu_invalid_dcache_line(&ptr->val);
+	mcs_barrier_flush(ptr);
+}
+
+///////////////////////////////////////////
+void mcs_barrier_wait( mcs_barrier_t * ptr)
+{
+	register uint32_t   phase;
+	register uint32_t   order;
+	uint32_t          * current;
+	uint32_t          * next;
+ 
+	phase   = ptr->phase.value;
+	current = (phase == 0) ? &ptr->ticket.value : &ptr->ticket2.value;
+	order   = cpu_atomic_add((void*)&ptr->cntr.value, -1);
+
+	if(order == 1)
+	{
+		phase            = ~(phase) & 0x1;
+		next             =  (phase == 0) ? &ptr->ticket.value : &ptr->ticket2.value;
+		ptr->phase.value = phase;
+		ptr->cntr.value  = ptr->val.value;
+		*next            = 0;
+		*current         = 1;
+		cpu_wbflush();
+		mcs_barrier_flush(ptr);
+		return;
+	}
+
+	mcs_barrier_flush(ptr);
+
+	while(cpu_load_word(current) == 0)
+		;
+
+	cpu_invalid_dcache_line(current);
+}
+
+/////////////////////////////////////
+void mcs_lock_init( mcs_lock_t * ptr,
+                    char       * name )
+{
+	ptr->cntr.value   = 0;
+	ptr->ticket.value = 0;
+	ptr->name         = name;
+	
+	cpu_wbflush();
+	cpu_invalid_dcache_line(&ptr->cntr);
+	cpu_invalid_dcache_line(&ptr->ticket);
+}
+
+////////////////////////////////
+void mcs_lock( mcs_lock_t * ptr, 
+               uint32_t   * irq_state )
+{
+	uint32_t ticket;
+
+	cpu_disable_all_irq( irq_state );
+
+	ticket = cpu_atomic_add( &ptr->ticket.value , 1 );
+
+	while(ticket != cpu_load_word(&ptr->cntr.value))
+		;
+
+	CURRENT_THREAD->locks_count ++;
+}
+
+//////////////////////////////////
+void mcs_unlock( mcs_lock_t * ptr, 
+                 uint32_t     irq_state )
+{
+	register uint32_t next;
+	volatile uint32_t *val_ptr;
+	register struct thread_s *this;
+
+	this	 = CURRENT_THREAD;
+
+	val_ptr  = &ptr->cntr.value;
+	next     = ptr->cntr.value + 1;
+
+	cpu_wbflush();
+	cpu_invalid_dcache_line((void*)val_ptr);
+
+	*val_ptr = next;
+
+	cpu_wbflush();
+	cpu_invalid_dcache_line((void*)val_ptr);
+
+	full_assert(this, this->locks_count > 0);
+	this->locks_count --;
+	cpu_restore_irq(irq_state);
+
+    // pourquoi pas simplement le code ci-dessous ? [AG]
+    // ptr->cntr.value ++;
+	// cpu_wbflush();
+    // CURRENT_THREAD->locks_count --;
+	// cpu_restore_irq( irq_state );
+    
+}
+
+///////////////////////////////////////
+void mcs_lock_remote( mcs_lock_t * ptr,
+                      cid_t        cid, 
+                      uint32_t   * irq_state )
+{
+	uint32_t ticket;
+
+	cpu_disable_all_irq( irq_state );
+
+	ticket = remote_atomic_add( &ptr->ticket.value , cid , 1 );
+
+	while( ticket != remote_lw( &ptr->cntr.value , cid ) )
+		;
+
+	CURRENT_THREAD->distlocks_count ++;
+}
+
+/////////////////////////////////////////
+void mcs_unlock_remote( mcs_lock_t * ptr, 
+                        cid_t        cid, 
+                        uint32_t     irq_state )
+{
+	register uint32_t next;
+	volatile uint32_t *val_ptr;
+	register struct thread_s *this;
+
+	this	 = CURRENT_THREAD;
+	val_ptr  = &ptr->cntr.value;
+	next     = remote_lw((void*)val_ptr, cid) + 1;
+
+	cpu_wbflush();
+	cpu_invalid_dcache_line((void*)val_ptr);
+
+	remote_sw((void*)val_ptr, cid, next);
+
+	cpu_wbflush();
+	cpu_invalid_dcache_line((void*)val_ptr);
+
+	full_assert(this, this->distlocks_count > 0);
+	this->distlocks_count --;
+	cpu_restore_irq(irq_state);
+}
Index: trunk/kernel/kern/mcs_sync.h
===================================================================
--- trunk/kernel/kern/mcs_sync.h	(revision 1)
+++ trunk/kernel/kern/mcs_sync.h	(revision 1)
@@ -0,0 +1,73 @@
+/*
+ * kern/mcs_sync.h - ticket-based barriers and locks synchronization
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _MCS_SYNC_H_
+#define _MCS_SYNC_H_
+
+#include <types.h>
+
+///////////////////////////////////////////////
+//             Public Section                //
+///////////////////////////////////////////////
+
+struct mcs_barrier_s;
+struct mcs_lock_s;
+
+typedef struct mcs_barrier_s mcs_barrier_t;
+typedef struct mcs_lock_s mcs_lock_t;
+
+void mcs_barrier_init(mcs_barrier_t *ptr, char *name, uint_t count);
+void mcs_barrier_wait(mcs_barrier_t *ptr);
+
+void mcs_lock_init(mcs_lock_t *ptr, char *name);
+
+void mcs_lock(mcs_lock_t *ptr, uint_t *irq_state);
+void mcs_unlock(mcs_lock_t *ptr, uint_t irq_state);
+
+void mcs_lock_remote(mcs_lock_t *ptr, cid_t cid, uint_t *irq_state);
+void mcs_unlock_remote(mcs_lock_t *ptr, cid_t cid, uint_t irq_state);
+
+//////////////////////////////////////////////
+//             Private Section              //
+//////////////////////////////////////////////
+
+struct mcs_barrier_s
+{
+	cacheline_t val;
+	cacheline_t phase;
+	cacheline_t cntr;
+	cacheline_t ticket;
+	cacheline_t ticket2;
+	char        *name CACHELINE;
+} mcs_barrier_t;
+
+
+struct mcs_lock_s
+{
+	cacheline_t cntr;
+	cacheline_t ticket;
+	char        *name CACHELINE;
+} mgs_lock_t;
+
+
+
+#endif	/* _MCS_SYNC_H_ */
